kio Library: KMimeMagic Class Reference (kio Library)

| # kio Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KMimeMagic Class Reference

`#include <kmimemagic.h>`

Collaboration diagram for KMimeMagic:

[legend]
List of all members.

## Public Member Functions
| KMimeMagic ()
| KMimeMagic (const QString &configFile)
| ~KMimeMagic ()
bool | mergeConfig (const QString &configFile)
bool | mergeBufConfig (char *)
void | setFollowLinks (bool _enable)
KMimeMagicResult * | findFileType (const QString &_filename)
KMimeMagicResult * | findBufferType (const QByteArray &p)
KMimeMagicResult * | findBufferFileType (const QByteArray &, const QString &filename)
## Static Public Member Functions
static KMimeMagic * | self ()
## Static Protected Member Functions
static void | initStatic ()
## Protected Attributes
KMimeMagicResult * | magicResult
## Static Protected Attributes
static KMimeMagic * | s_pSelf

## Detailed Description

Deprecated:
  Use KMimeType::findByContent() instead May be removed in KDE 4.0. Determine auto-magically the type of file, not only by using its extension, but also by reading its contents.

Unless specified otherwise, KMimeMagic uses $KDEDIR/share/mimelnk/magic for this purpose.

To make KMimeMagic restore the 'atime' of a file after it opened it, add its directory in kmimemagicrc like: [Settings] atimeDirs=/tmp,/var/tmp,/home/dfaure/tmp This isn't done by default because it changes the 'ctime'. See kmimemagic.cpp for a full discussion on this issue.

The basic usage of KMimeMagic is :

- Get a pointer to it, using KMimeMagic::self().
- Use it for any file or buffer you want, using one of the three `find`...Type() methods.

The result is contained in the class KMimeMagicResult.

Definition at line 101 of file kmimemagic.h.

## Constructor & Destructor Documentation

KMimeMagic::KMimeMagic | ( |  | ) |

| Create a parser and initialize it with the KDE-global data: the "magic" config file as well as the snippets from share/config/magic. Since: 3.1 Definition at line 2113 of file kmimemagic.cpp. References KGlobal::dirs(), endl(), KStandardDirs::findAllResources(), k_funcinfo, kdWarning(), locate(), and mergeConfig().

KMimeMagic::KMimeMagic | ( | const QString & | configFile | ) |

| Create a parser and initialize it with the given config file. Definition at line 2125 of file kmimemagic.cpp.

KMimeMagic::~KMimeMagic | ( |  | ) |

| Destroy the parser. Definition at line 2154 of file kmimemagic.cpp. References magicResult.

## Member Function Documentation

bool KMimeMagic::mergeConfig | ( | const QString & | configFile | ) |

| Merge an existing parse table with the data from the given file. Returns: `true` on success. Definition at line 2171 of file kmimemagic.cpp. References endl(), k_funcinfo, and kdDebug(). Referenced by KMimeMagic().

bool KMimeMagic::mergeBufConfig | ( | char * |  | ) |

| Merge an existing parse table with the data from the given buffer. Returns: `true` on success. Definition at line 2189 of file kmimemagic.cpp.

void KMimeMagic::setFollowLinks | ( | bool | _enable | ) |

| Enable/Disable follow-links. (Default is disabled.) Definition at line 2206 of file kmimemagic.cpp.

KMimeMagicResult * KMimeMagic::findFileType | ( | const QString & | _filename | ) |

| Try to find a MimeType for the given file. If no special MimeType is found, the default MimeType is returned. This function looks at the content of the file. Returns: A pointer to the result object. Do not delete the result object. After another call to KMimeMagic the returned result object changes its value since it is reused by KMimeMagic. Definition at line 2279 of file kmimemagic.cpp. References KMimeMagicResult::accuracy(), endl(), kdDebug(), magicResult, KMimeMagicResult::setAccuracy(), KMimeMagicResult::setInvalid(), and KMimeMagicResult::setMimeType(). Referenced by KMimeType::findByFileContent(), and KMimeType::findByURL().

KMimeMagicResult * KMimeMagic::findBufferType | ( | const QByteArray & | p | ) |

| Same functionality as above, except data is not read from a file. Instead a buffer can be supplied which is examined. Returns: A pointer to the result object. Do not delete the result object. After another call to KMimeMagic the returned result object changes its value since it is reused by KMimeMagic. Definition at line 2212 of file kmimemagic.cpp. References KMimeMagicResult::accuracy(), magicResult, KMimeMagicResult::setAccuracy(), KMimeMagicResult::setInvalid(), and KMimeMagicResult::setMimeType(). Referenced by findBufferFileType(), and KMimeType::findByContent().

KMimeMagicResult * KMimeMagic::findBufferFileType | ( | const QByteArray & | ,
|  | const QString & | filename
| ) |

| Same functionality as findBufferType() but with additional capability of distinguishing between C-headers and C-Source. For this purpose this function looks at the extension of the filename. This means that 'filename' can be a filename on some FTP server, too. Returns: A pointer to the result object. Do not delete the result object. After another call to KMimeMagic the returned result object changes its value since it is reused by KMimeMagic. Definition at line 2268 of file kmimemagic.cpp. References findBufferType().

KMimeMagic * KMimeMagic::self | ( |  | ) | `[static]`

| Returns a pointer to the unique KMimeMagic instance in this process. Definition at line 41 of file kmimemagic.cpp. Referenced by KMimeType::findByContent(), KMimeType::findByFileContent(), and KMimeType::findByURL().

## Member Data Documentation

KMimeMagicResult* KMimeMagic::magicResult`[protected]`

| The result type. Definition at line 197 of file kmimemagic.h. Referenced by findBufferType(), findFileType(), and ~KMimeMagic().

The documentation for this class was generated from the following files:

- kmimemagic.h
- kmimemagic.cpp

This file is part of the documentation for kio Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:24:57 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003